glibmm 2.62.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Protected Member Functions | List of all members
Glib::ExtraClassInit Class Reference

A convenience class for named custom types. More...

`#include <glibmm/extraclassinit.h>`

Inheritance diagram for Glib::ExtraClassInit:
[legend]

## Protected Member Functions
| ExtraClassInit (GClassInitFunc class_init_func, void* class_data=nullptr, GInstanceInitFunc instance_init_func=nullptr)
| Constructor. More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Detailed Description

A convenience class for named custom types.

Use it if you need to add code to GType's class init function and/or need an instance init function. Example:

#include <glibmm/extraclassinit.h>
class MyExtraInit : public Glib::ExtraClassInit
{
public:
MyExtraInit(const Glib::ustring& css_name)
:
Glib::ExtraClassInit(my_extra_class_init_function,& m_css_name, my_instance_init_function),
m_css_name(css_name)
{ }
private:
static void my_extra_class_init_function(void* g_class, void* class_data)
{
const auto klass = static_cast<GtkWidgetClass*>(g_class);
const auto css_name = static_cast<Glib::ustring*>(class_data);
gtk_widget_class_set_css_name(klass, css_name->c_str());
}
static void my_instance_init_function(GTypeInstance* instance, void* g_class)
{
gtk_widget_set_has_surface(GTK_WIDGET(instance), true);
}
Glib::ustring m_css_name;
};
class MyWidget : public MyExtraInit, public Gtk::Widget
{
public:
MyWidget()
:
// The GType name will be gtkmm__CustomObject_MyWidget
Glib::ObjectBase("MyWidget"), // Unique class name
MyExtraInit("my-widget"),
Gtk::Widget()
{
// ...
}
// ...
};

Note
  Classes derived from ExtraClassInit (MyExtraInit in the example) must be listed before Glib::Object or a class derived from Glib::Object (Gtk::Widget in the example) in the list of base classes.

Since glibmm 2.60:

## Constructor & Destructor Documentation

Glib::ExtraClassInit::ExtraClassInit | ( | GClassInitFunc | class_init_func,
|  | void * | class_data = `nullptr`,
|  | GInstanceInitFunc | instance_init_func = `nullptr`
| ) |  |
| explicit protected

Constructor.

Parameters

  class_init_func | Pointer to an extra class init function. nullptr, if no extra class init function is needed.
  class_data | Class data pointer, passed to the class init function. Can be nullptr, if the class init function does not need it.
  instance_init_func | Pointer to an instance init function. nullptr, if no instance init function is needed.